class SendMessageResponse {
  final bool success;
  final int errorID;
  final int errorHighlight;
  final String message;
  final bool suppressSend;
  final int messageCount;
  final int quota;
  final bool isPro;
  final int quotaMax;
  final String scnMessageID;

  SendMessageResponse({
    required this.success,
    required this.errorID,
    required this.errorHighlight,
    required this.message,
    required this.suppressSend,
    required this.messageCount,
    required this.quota,
    required this.isPro,
    required this.quotaMax,
    required this.scnMessageID,
  });

  factory SendMessageResponse.fromJson(Map<String, dynamic> json) {
    return SendMessageResponse(
      success: json['success'] as bool,
      errorID: json['error'] as int,
      errorHighlight: json['errhighlight'] as int,
      message: json['message'] as String,
      suppressSend: json['suppress_send'] as bool,
      messageCount: json['messagecount'] as int,
      quota: json['quota'] as int,
      isPro: json['is_pro'] as bool,
      quotaMax: json['quota_max'] as int,
      scnMessageID: json['scn_msg_id'] as String,
    );
  }

  Map<String, dynamic> toJson() {
    return {
      'success': success,
      'error': errorID,
      'errhighlight': errorHighlight,
      'message': message,
      'suppress_send': suppressSend,
      'messagecount': messageCount,
      'quota': quota,
      'is_pro': isPro,
      'quota_max': quotaMax,
      'scn_msg_id': scnMessageID,
    };
  }
}
